﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TestView.Ensaios;
using TestView.Ensaios.Utilidades.CorposDeProva;
using TestView.Condicionador;
using TestView.Ensaios.Utilidades;
using ModuloEnsaioTracao.Graficos;
using TestView.Ensaios.Utilidades.Coleta;

namespace ModuloEnsaioTracao
{
    public class EnsaioTracao : IEnsaio
    {
        #region Construtor e membros

        private DateTime _dataEnsaio;
        private ICorpoDeProva _corpoProva;
        private Aquisicao _aquisicao;
        private OpcoesGraficoTracao _opcoesGrafico;

        public EnsaioTracao()
        {
            this._dataEnsaio = DateTime.Now;
            this._aquisicao = new Aquisicao();
            this._opcoesGrafico = new OpcoesGraficoTracao();
        }

        public DateTime DataEnsaio
        {
            get
            {
                return this._dataEnsaio;
            }
        }

        public ICorpoDeProva CorpoDeProva
        {
            get
            {
                return this._corpoProva;
            }
            set
            {
                this._corpoProva = value;
            }
        }

        public Aquisicao Aquisicao
        {
            get
            {
                return this._aquisicao;
            }
        }

        public OpcoesGraficoTracao OpcoesGrafico
        {
            get
            {
                return this._opcoesGrafico;
            }
            set
            {
                this._opcoesGrafico = value;
            }
        }

        #endregion

        #region Misc

        public override string ToString()
        {
            return String.Format("Ensaio de Tração {0:dd-MM-yy HH:mm}", this.DataEnsaio);
        }

        #endregion
    }
}
