﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TestView.Ensaios;

namespace ModuloEnsaioTracao
{
    public class ModuloEnsaioTracao : ModuloDeEnsaio
    {
        #region Construtor e membros
        private const int ID = 1;

        private ModuloGUI _moduloGui;
        private RotinaDeEnsaio _rotinaDeEnsaio;

        public ModuloEnsaioTracao()
        {
            this._moduloGui = new ModuloTracaoGUI(this);
            this._rotinaDeEnsaio = new RotinaDeEnsaioTracao(this);
        }

        public override RotinaDeEnsaio RotinaDeEnsaio
        {
            get
            {
                return this._rotinaDeEnsaio;
            }
        }
        public override ModuloGUI FachadaGUI
        {
            get 
            {
                return this._moduloGui;
            }
        }
        public override String NomeEnsaio
        {
            get
            {
                return Properties.Resources.descricaoEnsaioString;
            }
        }
        public override String NomeModulo
        {
            get
            {
                return Properties.Resources.descricaoModuloString;
            }
        }
        public override int Id
        {
            get
            {
                return ID;
            }
        }
        public override String Versao
        {
            get
            {
                return this.GetType().Assembly.GetName().Version.ToString();
            }
        }


        #endregion
    }
}
