﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TestView.Ensaios;
using System.IO;
using System.Data;

namespace TestView.Dados.Modelo
{
    public class EnsaioDAO : IObjetoDAO<EnsaioDTO>
    {
        public EnsaioDAO() { }

        public List<EnsaioDTO> listarTodos()
        {
            List<EnsaioDTO> lista = new List<EnsaioDTO>();
            ConexaoBD conexao = FabricaConexoesBD.getInstance().obtemConexao();
            String sql = "SELECT * FROM Ensaio";
            DataTable resultado = conexao.executaComando(sql, "Listar Ensaios");
            for (int i = 0; i < resultado.Rows.Count; i++)
            {
                String id = Convert.ToString(resultado.Rows[i]["idEnsaio"]);
                DateTime data = Convert.ToDateTime(resultado.Rows[i]["dataEnsaio"]);
                String ensaioString = Convert.ToString(resultado.Rows[i]["ensaio"]);
                int idModulo = Convert.ToInt32(resultado.Rows[i]["idModuloEnsaio"]);

                EnsaioDTO ensaioDto = new EnsaioDTO(id, data, ensaioString, idModulo);
                lista.Add(ensaioDto);
            }
            conexao.EmUtilizacao = false;
            return lista;
        }

        public void deletar(EnsaioDTO modulo)
        {
            ConexaoBD conexao = FabricaConexoesBD.getInstance().obtemConexao();
            String sql = String.Format(@"DELETE FROM Ensaio WHERE idEnsaio = '{0}'", modulo.IdEnsaio);
            conexao.executaComandoSemRetorno(sql, "Deletar Ensaio");
            conexao.EmUtilizacao = false;
        }

        public void inserir(EnsaioDTO ensaio)
        {
            ConexaoBD conexao = FabricaConexoesBD.getInstance().obtemConexao();
            String sql = String.Format(@"INSERT INTO Ensaio VALUES ('{0}', '{1:yyyy-MM-dd HH:mm:ss}', '{2}', {3})", ensaio.IdEnsaio, ensaio.DataEnsaio, ensaio.Ensaio, ensaio.IdModuloEnsaio);
            conexao.executaComandoSemRetorno(sql, "Inserir Modulo");
            conexao.EmUtilizacao = false;
        }

        public void atualizar(EnsaioDTO antigo, EnsaioDTO novo)
        {
            ConexaoBD conexao = FabricaConexoesBD.getInstance().obtemConexao();
            String sql = String.Format(@"
                UPDATE Ensaio 
                SET idEnsaio = '{0}', dataEnsaio = '{1:yyyy-MM-dd HH:mm:ss}', ensaio = '{2}', idModuloEnsaio = {3}
                WHERE idEnsaio = '{4}'
                ", novo.IdEnsaio, novo.DataEnsaio, novo.Ensaio, novo.IdModuloEnsaio, antigo.IdEnsaio);
            conexao.executaComandoSemRetorno(sql, "Ataulizar Modulo");
            conexao.EmUtilizacao = false;
        }

        public List<EnsaioDTO> listarEnsaiosPorId(string id)
        {
            List<EnsaioDTO> lista = new List<EnsaioDTO>();
            ConexaoBD conexao = FabricaConexoesBD.getInstance().obtemConexao();
            String sql = String.Format("SELECT dataEnsaio, idModuloEnsaio FROM Ensaio WHERE idEnsaio = '{0}'", id);
            DataTable resultado = conexao.executaComando(sql, "Listar Ensaios Por ID");
            for (int i = 0; i < resultado.Rows.Count; i++)
            {
                DateTime data = Convert.ToDateTime(resultado.Rows[i]["dataEnsaio"]);
                int idModulo = Convert.ToInt32(resultado.Rows[i]["idModuloEnsaio"]);

                EnsaioDTO ensaioDto = new EnsaioDTO(id, data, null, idModulo);
                lista.Add(ensaioDto);
            }
            conexao.EmUtilizacao = false;
            return lista;
        }

        public DataTable listarEnsaiosSomenteTexto(String[] idEnsaios, DateTime dataInicio, DateTime dataFim)
        {
            ConexaoBD conexao = FabricaConexoesBD.getInstance().obtemConexao();
            
            String clausulasWhere = String.Empty;
            if (idEnsaios.Length > 0)
            {
                for (int i = 0; i < idEnsaios.Length; i++)
                {
                    idEnsaios[i] = String.Format("'{0}'", idEnsaios[i]);
                }
                String listaIdEnsaios = String.Join(", ", idEnsaios);
                if (!clausulasWhere.Equals(String.Empty))
                {
                    clausulasWhere += "AND ";
                }
                clausulasWhere += String.Format("e.idEnsaio IN ({0})", listaIdEnsaios);
            }
            if (!dataInicio.Equals(DateTime.MinValue) && !dataFim.Equals(DateTime.MaxValue))
            {
                if (dataInicio > dataFim)
                {
                    DateTime dataAuxiliar = dataInicio;
                    dataInicio = dataFim;
                    dataFim = dataAuxiliar;
                }
                if (!clausulasWhere.Equals(String.Empty))
                {
                    clausulasWhere += " AND ";
                }
                clausulasWhere += String.Format("e.dataEnsaio >= '{0:yyyy-MM-dd HH:mm:ss}' AND e.dataEnsaio <= '{1:yyyy-MM-dd HH:mm:ss}'", dataInicio, dataFim);
            }
            if (!clausulasWhere.Equals(String.Empty))
            {
                clausulasWhere = "WHERE " + clausulasWhere;
            }

            String sql = String.Format("SELECT e.idEnsaio, e.dataEnsaio, m.nome FROM Ensaio AS e INNER JOIN ModuloEnsaio AS m ON e.idModuloEnsaio = m.idModuloEnsaio {0} ORDER BY e.dataEnsaio DESC", clausulasWhere);
            DataTable resultado = conexao.executaComando(sql, "Listar Ensaios Para exibição");
            conexao.EmUtilizacao = false;
            return resultado;
        }

        public EnsaioDTO carregar(EnsaioDTO ensaio)
        {
            ConexaoBD conexao = FabricaConexoesBD.getInstance().obtemConexao();
            String sql = String.Format(@"SELECT * FROM Ensaio WHERE idEnsaio = '{0}'", ensaio.IdEnsaio);
            DataTable resultado = conexao.executaComando(sql, "Carregar Ensaio");
            if (resultado.Rows.Count != 0)
            {
                DateTime data = Convert.ToDateTime(resultado.Rows[0]["dataEnsaio"]);
                String ensaioString = Convert.ToString(resultado.Rows[0]["ensaio"]);
                int idModuloEnsaio = Convert.ToInt32(resultado.Rows[0]["idModuloEnsaio"]);
                ensaio.Ensaio = ensaioString;
                ensaio.DataEnsaio = data;
                ensaio.IdModuloEnsaio = idModuloEnsaio;
            }
            conexao.EmUtilizacao = false;
            return ensaio;
        }
    }
}
