﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TestView.Ensaios;
using System.IO;

namespace TestView.Dados.Modelo
{
    public class EnsaioDTO
    {
        #region Construtor e membros

        private String _idEnsaio;
        private DateTime _dataEnsaio;
        private String _ensaio;
        private int _idModuloEnsaio;

        public EnsaioDTO(string id, DateTime dataEnsaio, string ensaio, int idModuloEnsaio)
        {
            this.IdEnsaio = id;
            this.DataEnsaio = dataEnsaio;
            this.Ensaio = ensaio;
            this.IdModuloEnsaio = idModuloEnsaio;
        }
        public EnsaioDTO(Ensaio ensaio, ModuloDeEnsaio moduloEnsaio)
        {
            this.IdEnsaio = ensaio.Id;
            this.DataEnsaio = ensaio.DataEnsaio;

            MemoryStream stream = new MemoryStream();
            ensaio.serializaEnsaio(stream);
            byte[] bytesEnsaio = stream.ToArray();
            this.Ensaio = System.Text.Encoding.UTF8.GetString(bytesEnsaio);

            this.IdModuloEnsaio = moduloEnsaio.Id;
        }

        public String IdEnsaio
        {
            get
            {
                return this._idEnsaio;
            }
            set
            {
                this._idEnsaio = value;
            }
        }
        public DateTime DataEnsaio
        {
            get
            {
                return this._dataEnsaio;
            }
            set
            {
                this._dataEnsaio = value;
            }
        }
        public String Ensaio
        {
            get
            {
                return this._ensaio;
            }
            set
            {
                this._ensaio = value;
            }
        }
        public int IdModuloEnsaio
        {
            get
            {
                return this._idModuloEnsaio;
            }
            set
            {
                this._idModuloEnsaio = value;
            }
        }

        #endregion
    }
}
