﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TestView.Ensaios;
using System.Data;

namespace TestView.Dados.Modelo
{
    public class ModuloEnsaioDAO : IObjetoDAO<ModuloEnsaioDTO>
    {
        #region Construtor e membros

        public ModuloEnsaioDAO() { }

        #endregion

        #region Dados

        public void atualizar(ModuloEnsaioDTO antigo, ModuloEnsaioDTO novo)
        {
            ConexaoBD conexao = FabricaConexoesBD.getInstance().obtemConexao();
            String sql = String.Format(@"
                UPDATE ModuloEnsaio 
                SET idModuloEnsaio = {0}, nome = '{1}'
                WHERE idModuloEnsaio = {2}
                ", novo.Id, novo.NomeModulo, antigo.Id);
            conexao.executaComandoSemRetorno(sql, "Ataulizar Modulo");
            conexao.EmUtilizacao = false;
        }

        public void deletar(ModuloEnsaioDTO modulo)
        {
            ConexaoBD conexao = FabricaConexoesBD.getInstance().obtemConexao();
            String sql = String.Format(@"DELETE FROM ModuloEnsaio WHERE idModuloEnsaio = {0}", modulo.Id);
            conexao.executaComandoSemRetorno(sql, "Deletar Modulo");
            conexao.EmUtilizacao = false;
        }

        public void inserir(ModuloEnsaioDTO modulo)
        {
            ConexaoBD conexao = FabricaConexoesBD.getInstance().obtemConexao();
            String sql = String.Format(@"INSERT INTO ModuloEnsaio VALUES ({0}, '{1}')", modulo.Id, modulo.NomeModulo);
            conexao.executaComandoSemRetorno(sql, "Inserir Modulo");
            conexao.EmUtilizacao = false;
        }

        public ModuloEnsaioDTO carregar(ModuloEnsaioDTO modulo)
        {
            ConexaoBD conexao = FabricaConexoesBD.getInstance().obtemConexao();
            String sql = String.Format(@"SELECT * FROM ModuloEnsaio WHERE idModuloEnsaio = {0}", modulo.Id);
            DataTable resultado = conexao.executaComando(sql, "Carregar Modulo");
            if (resultado.Rows.Count != 0)
            {
                String nome = Convert.ToString(resultado.Rows[0]["nome"]);
                modulo.NomeModulo = nome;
            }
            conexao.EmUtilizacao = false;
            return modulo;
        }

        public List<ModuloEnsaioDTO> listarModulosPorId(int id)
        {
            ConexaoBD conexao = FabricaConexoesBD.getInstance().obtemConexao();
            String sql = String.Format(@"SELECT * FROM ModuloEnsaio WHERE idModuloEnsaio = {0}", id);
            DataTable resultado = conexao.executaComando(sql, "listarListarModulosPorId");

            List<ModuloEnsaioDTO> modulos = new List<ModuloEnsaioDTO>();
            if (resultado.Rows.Count != 0)
            {
                int idModulo = Convert.ToInt32(resultado.Rows[0]["idModuloEnsaio"]);
                String nome = Convert.ToString(resultado.Rows[0]["nome"]);
                ModuloEnsaioDTO modulo = new ModuloEnsaioDTO(idModulo, nome);
                modulos.Add(modulo);
            }
            conexao.EmUtilizacao = false;
            return modulos;
        }

        public List<ModuloEnsaioDTO> listarTodos()
        {
            List<ModuloEnsaioDTO> lista = new List<ModuloEnsaioDTO>();
            ConexaoBD conexao = FabricaConexoesBD.getInstance().obtemConexao();
            String sql = "SELECT * FROM ModuloEnsaio";
            DataTable resultado = conexao.executaComando(sql, "Listar Modulos");
            for (int i = 0; i < resultado.Rows.Count; i++)
            {
                int id = Convert.ToInt32(resultado.Rows[i]["idModuloEnsaio"]);
                String nome = Convert.ToString(resultado.Rows[i]["nome"]);
                ModuloEnsaioDTO moduloDTO = new ModuloEnsaioDTO(id, nome);
                lista.Add(moduloDTO);
            }
            conexao.EmUtilizacao = false;
            return lista;
        }

        #endregion
    }
}
