﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace TestView.Ensaios.Graficos
{
    [DataContract]
    public class TipoCoordenada
    {
        public static readonly TipoCoordenada TEMPO = new TipoCoordenada(0, "Tempo");
        public static readonly TipoCoordenada FORCA = new TipoCoordenada(1, "Força");
        public static readonly TipoCoordenada TENSAO = new TipoCoordenada(2, "Tensão");
        public static readonly TipoCoordenada DEFORMACAO = new TipoCoordenada(3, "Deformação");
        public static readonly TipoCoordenada DESLOCAMENTO = new TipoCoordenada(4, "Deslocamento");
        public static readonly Dictionary<String, TipoCoordenada> MapaCoordenada = new Dictionary<string, TipoCoordenada>
        {
            {TEMPO.ToString(), TEMPO},
            {FORCA.ToString(), FORCA},
            {TENSAO.ToString(), TENSAO},
            {DEFORMACAO.ToString(), DEFORMACAO},
            {DESLOCAMENTO.ToString(), DESLOCAMENTO},
        };

        private int _id;
        private string _nome;

        public TipoCoordenada(int id, string nome)
        {
            this._id = id;
            this._nome = nome;
        }

        [DataMember]
        public int Id
        {
            get
            {
                return this._id;
            }
            set
            {
                this._id = value;
            }
        }

        [DataMember]
        public string Nome
        {
            get
            {
                return this._nome;
            }
            set
            {
                this._nome = value;
            }
        }

        public override string ToString()
        {
            return this._nome;
        }

    }
}
