﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

namespace TestView.Ensaios.Modulos
{
    public class BibliotecaModulo
    {
        #region Construtor e membros

        private string _nomeEnsaio;
        private string _nomeClasseModulo;
        private string _nomeClasseEnsaio;
        private Assembly _assembly;

        public BibliotecaModulo(Assembly assembly, string nomeClasseModulo, string nomeClasseEnsaio)
        {
            this._nomeEnsaio = null;
            this._assembly = assembly;
            this._nomeClasseModulo = nomeClasseModulo;
            this._nomeClasseEnsaio = nomeClasseEnsaio;
        }

        public string NomeEnsaio
        {
            get
            {
                if (this._nomeEnsaio == null)
                {
                    ModuloDeEnsaio moduloEnsaio = this.obtemNovaInstanciaModulo();
                    this._nomeEnsaio = moduloEnsaio.NomeEnsaio;
                }
                return this._nomeEnsaio;
            }
        }

        public String NomeClasseModulo
        {
            get
            {
                return this._nomeClasseModulo;
            }
        }

        public String NomeClasseEnsaio
        {
            get
            {
                return this._nomeClasseEnsaio;
            }
        }

        public Assembly Assembly
        {
            get
            {
                return this._assembly;
            }
            set
            {
                this._assembly = value;
            }
        }

        #endregion

        #region Carregador

        public ModuloDeEnsaio obtemNovaInstanciaModulo()
        {
            Type tipo = this.Assembly.GetType(this.NomeClasseModulo);
            ModuloDeEnsaio modulo = (ModuloDeEnsaio)Activator.CreateInstance(tipo);
            return modulo;
        }

        public Ensaio obtemNovaInstanciaEnsaio()
        {
            Type tipo = this.Assembly.GetType(this.NomeClasseEnsaio);
            Ensaio ensaio = (Ensaio)Activator.CreateInstance(tipo);
            return ensaio;
        }

        #endregion
    }
}
