﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing.Printing;
using TestView.Dados;

namespace TestView.Ensaios
{
    public enum EstadoEnsaio
    {
        NAO_INICIADO,
        INICIADO,
        TERMINADO,
        FECHADO,
    }

    public abstract class RotinaDeEnsaio
    {
        public abstract Ensaio Ensaio
        {
            get;
            set;
        }

        public abstract ModuloDeEnsaio ModuloEnsaio
        {
            get;
        }

        public void iniciaEnsaio()
        {
            this.iniciaEnsaioEspecifico();
        }

        public abstract void iniciaEnsaioEspecifico();

        public void terminaEnsaio()
        {
            this.terminaEnsaioEspecifico();
            if (BancoDeDados.getInstance().UtilizarBancoDados)
            {
                GerenciadorEnsaios.getInstance().salvarEnsaioBancoDados(this.ModuloEnsaio);
            }
        }

        public abstract void terminaEnsaioEspecifico();

        public void abrirEnsaio(Ensaio ensaio)
        {
            this.abrirEnsaioEspecifico(ensaio);
        }

        public abstract void abrirEnsaioEspecifico(Ensaio ensaio);

        public abstract void imprimeRelatorio(PrintPageEventArgs e);
    }
}
