﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TestView.MyMath
{
    public class AjusteDeCurvaPolinomial
    {
        private List<Ponto> _pontos;
        private double[,] _matrizA;
        private double[] _vetorB;

        public AjusteDeCurvaPolinomial(List<Ponto> pontos)
        {
            this._pontos = pontos;
        }

        private void inicializaEstruturas(int grauPolinomio)
        {
            this._matrizA = new double[this._pontos.Count, grauPolinomio + 1];
            this._vetorB = new double[this._pontos.Count];
            for (int i = 0; i < this._pontos.Count; i++)
            {
                Ponto ponto = this._pontos[i];
                for (int j = 0; j <= grauPolinomio; j++)
                {
                    this._matrizA[i, j] = Math.Pow(ponto.X, j);
                }
                this._vetorB[i] = ponto.Y;
            }
        }

        public Polinomio ajustar(int grauPolinomio)
        {
            this.inicializaEstruturas(grauPolinomio);
            MinimosQuadrados mmq = new MinimosQuadrados(this._matrizA, this._vetorB);
            double[] coeficientes = mmq.resolucao();
            Polinomio polinomio = new Polinomio(coeficientes);
            return polinomio;
        }

        public Reta ajustarReta()
        {
            Polinomio polinomioReta = this.ajustar(1);
            Ponto ponto = new Ponto(0, polinomioReta.Coeficientes[0]);
            Double inclinacao = polinomioReta.Coeficientes[1];
            Reta reta = new Reta(ponto, inclinacao);
            return reta;
        }
    }
}
