﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TestView.MyMath
{
    public class Conversor
    {
        public static Double converterForca(double valor, Unidade unidadeOrigem, Unidade unidadeDestino)
        {
            double valorFinal = valor;
            if (unidadeOrigem.Equals(Unidade.KGF))
            {
                if (unidadeDestino.Equals(Unidade.N))
                {
                    valorFinal = valor * 9.80665;
                }
                else if (unidadeDestino.Equals(Unidade.LBF))
                {
                    valorFinal = valor * 2.2046226218;
                }
                else if (unidadeDestino.Equals(Unidade.DYN))
                {
                    valorFinal = valor * 980665;
                }
                else if (unidadeDestino.Equals(Unidade.KN))
                {
                    valorFinal = valor * 0.00980665;
                }
                else if (unidadeDestino.Equals(Unidade.DAN))
                {
                    valorFinal = valor * 0.980665;
                }
                else if (unidadeDestino.Equals(Unidade.TF))
                {
                    valorFinal = valor * 0.001;
                }
                else if (unidadeDestino.Equals(Unidade.GF))
                {
                    valorFinal = valor * 1000;
                }
            }
            else if (unidadeOrigem.Equals(Unidade.N))
            {
                valorFinal = converterForca(valor * 0.1019716213, Unidade.KGF, unidadeDestino);
            }
            else if (unidadeOrigem.Equals(Unidade.KN))
            {
                valorFinal = converterForca(valor * 101.9716213, Unidade.KGF, unidadeDestino);
            }
            else if (unidadeOrigem.Equals(Unidade.GF))
            {
                valorFinal = converterForca(valor * 0.001, Unidade.KGF, unidadeDestino);
            }
            else if (unidadeOrigem.Equals(Unidade.DAN))
            {
                valorFinal = converterForca(valor * 1.019716213, Unidade.KGF, unidadeDestino);
            }
            else if (unidadeOrigem.Equals(Unidade.LBF))
            {
                valorFinal = converterForca(valor / 2.2046226218, Unidade.KGF, unidadeDestino);
            }
            else if (unidadeOrigem.Equals(Unidade.DYN))
            {
                valorFinal = converterForca(valor / 980665, Unidade.KGF, unidadeDestino);
            }
            else if (unidadeOrigem.Equals(Unidade.TF))
            {
                valorFinal = converterForca(valor * 1000, Unidade.KGF, unidadeDestino);
            }
            return valorFinal;
        }

        public static Double converterTensao(double valor, Unidade unidadeOrigem, Unidade unidadeDestino)
        {
            double valorFinal = valor;
            if (unidadeOrigem.Equals(Unidade.MPA))
            {
                if (unidadeDestino.Equals(Unidade.KPA))
                {
                    valorFinal = valor * 1000;
                }
                else if (unidadeDestino.Equals(Unidade.PA))
                {
                    valorFinal = valor * 1000000;
                }
                else if (unidadeDestino.Equals(Unidade.PSI))
                {
                    valorFinal = valor * 145.0377;
                }
                else if (unidadeDestino.Equals(Unidade.KGF_MM2))
                {
                    valorFinal = valor * 0.1019716213;
                }
                else if (unidadeDestino.Equals(Unidade.GPA))
                {
                    valorFinal = valor * 0.001;
                }
            }
            else if (unidadeOrigem.Equals(Unidade.KPA))
            {
                valorFinal = converterTensao(valor * 1000, Unidade.MPA, unidadeDestino);
            }
            else if (unidadeOrigem.Equals(Unidade.PA))
            {
                valorFinal = converterTensao(valor * 1000, Unidade.KPA, unidadeDestino);
            }
            else if (unidadeOrigem.Equals(Unidade.PSI))
            {
                valorFinal = converterTensao(valor / 145.0377, Unidade.MPA, unidadeDestino);
            }
            else if (unidadeOrigem.Equals(Unidade.GPA))
            {
                valorFinal = converterTensao(valor * 1000, Unidade.MPA, unidadeDestino);
            }
            else if (unidadeOrigem.Equals(Unidade.KGF_MM2))
            {
                valorFinal = converterTensao(valor * 9.80665, Unidade.MPA, unidadeDestino);
            }
            return valorFinal;
        }

        public static Double converterComprimento(double valor, Unidade unidadeOrigem, Unidade unidadeDestino, double comprimentoExtensometrico)
        {
            double valorFinal = valor;
            if (unidadeOrigem.Equals(Unidade.MM))
            {
                if (unidadeDestino.Equals(Unidade.PERCENTUAL_EXT))
                {
                    valorFinal = valor / comprimentoExtensometrico;
                }
            }
            else if (unidadeOrigem.Equals(Unidade.PERCENTUAL_EXT))
            {
                valorFinal = converterComprimento(valor * comprimentoExtensometrico, Unidade.MM, unidadeDestino, comprimentoExtensometrico);
            }
            return valorFinal;
        }
    }
}
