﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TestView.MyMath
{
    public class Reta
    {
        private double _inclinacao;
        private Ponto _ponto;

        public Reta(Ponto ponto, double inclinacao)
        {
            this._ponto = ponto;
            this._inclinacao = inclinacao;
        }

        public Reta(Ponto ponto1, Ponto ponto2)
        {
            this._ponto = ponto1;
            this._inclinacao = (ponto1.Y - ponto2.Y) / (ponto1.X - ponto2.X);
        }

        public double Inclinacao
        {
            get
            {
                return this._inclinacao;
            }
        }

        public Ponto Ponto
        {
            get
            {
                return this._ponto;
            }
        }

        public double obtemValorAbscissa(double valorOrdenada)
        {
            //y - y0 = m(x - x0)
            if (double.IsInfinity(this._inclinacao))
            {
                return this._inclinacao;
            }
            else if (double.IsNaN(this._inclinacao))
            {
                return double.NaN;
            }
            else
            {
                return (valorOrdenada - this._ponto.Y) / this._inclinacao + this._ponto.X;
            }
        }

        public double obtemValorOrdenada(double valorAbscissa)
        {
            //y - y0 = m(x - x0)
            if (double.IsInfinity(this._inclinacao))
            {
                return this._inclinacao;
            }
            else if (double.IsNaN(this._inclinacao))
            {
                return double.NaN;
            }
            else
            {
                return this._inclinacao * (valorAbscissa - this._ponto.X) + this._ponto.Y;
            }
        }

        public Ponto obtemInterseccao(Reta reta)
        {
            if (this.Inclinacao == reta.Inclinacao)
            {
                return null;
            }
            else
            {
                double x = ((this.Inclinacao * this.Ponto.X - this.Ponto.Y) - (reta.Inclinacao * reta.Ponto.X - reta.Ponto.Y)) / (this.Inclinacao - reta.Inclinacao);
                double y = this.obtemValorOrdenada(x);
                return new Ponto(x, y);
            }
        }
    }
}
