﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using TestView.Seguranca;

namespace TestView.Utils
{
    public class Temporizador
    {
        private int _intervalo;
        private bool _ativo;
        private bool _trabalhando;
        public delegate void FuncaoTemporizador();
        private FuncaoTemporizador _temporizadorCallback;
        private Thread _threadTemporizador;

        public Boolean Trabalhando
        {
            get
            {
                return this._trabalhando;
            }
        }

        public Temporizador(int intervalo, FuncaoTemporizador callback)
        {
            this._intervalo = intervalo;
            this._ativo = false;
            this._trabalhando = false;
            this._temporizadorCallback = callback;
        }

        public void inicia()
        {
            if (!this._ativo)
            {
                this._ativo = true;
                this._trabalhando = true;
                this._threadTemporizador = new Thread(new ThreadStart(funcaoTemporizador));
                this._threadTemporizador.Priority = ThreadPriority.Highest;
                this._threadTemporizador.Name = String.Format("Temporizador{0}", this._threadTemporizador.ManagedThreadId);
                this._threadTemporizador.Start();
            }
        }

        public void para()
        {
            if (this._ativo)
            {
                this._ativo = false;
            }
        }

        private void funcaoTemporizador()
        {
            while (this._ativo)
            {
                this._temporizadorCallback();
                Thread.Sleep(this._intervalo);
            }
            this._trabalhando = false;
        }
    }
}
