﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TestView.Utils
{
    public static class Validacao
    {
        /// <summary>
        /// Valida se o texto é um valor numérico.
        /// </summary>
        /// <param name="texto">Texto a ser validado</param>
        /// <returns>Devolve true se o texto é um valor numérico.</returns>
        public static bool validaTextoNumerico(String texto)
        {
            if (texto == null)
            {
                return false;
            }
            else
            {
                double valor = double.NaN;
                if (Double.TryParse(texto, out valor))
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
        }

        public static bool validaValorNaoNulo(String texto)
        {
            double valor = double.Parse(texto);
            return validaValorNaoNulo(valor);
        }

        public static bool validaValorNaoNulo(double valor)
        {
            if (valor.Equals(0d))
            {
                return false;
            }
            else if (Math.Abs(valor) < double.Epsilon)
            {
                return false;
            }
            else
            {
                return true;
            }
        }

        public static bool validaIntervaloValorNumerico(double valor, double inicioIntervalo, double finalIntervalo)
        {
            double min = Math.Min(inicioIntervalo, finalIntervalo);
            double max = Math.Max(inicioIntervalo, finalIntervalo);
            if (min <= valor && valor <= max)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
    }
}
