﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using TestView.Ensaios;
using TestView.Dados;

namespace TestViewGUI.Dados
{
    public partial class FormBancoDados : Form
    {
        #region Construtor e membros

        public FormBancoDados()
        {
            InitializeComponent();
            this.inicializarLayout();
        }

        #endregion

        #region Layout

        private void inicializarLayout()
        {
            this.inicializarCheckboxes();
            this.inicializaComboboxes();
            this.inicializaTextboxes();
        }

        private void inicializarCheckboxes()
        {
            this.checkBoxUtilizarBancoDados.Checked = BancoDeDados.getInstance().UtilizarBancoDados;
        }

        private void inicializaComboboxes()
        {
            this.comboBoxDataSource.Items.Clear();
            foreach (String dataSource in BancoDeDados.listarInstanciasSqlServer())
            {
                this.comboBoxDataSource.Items.Add(dataSource);
            }
            this.comboBoxDataSource.Text = BancoDeDados.getInstance().DataSource;
        }

        private void inicializaTextboxes()
        {
            this.textBoxSenha.Text = BancoDeDados.getInstance().Senha;
            this.textBoxUsuario.Text = BancoDeDados.getInstance().NomeUsuario;
        }

        #endregion

        #region Salvar

        public void salvarOpcoesBancoDados()
        {
            Boolean utilizarBd = this.checkBoxUtilizarBancoDados.Checked;
            String nomeUsuario = this.textBoxUsuario.Text;
            String senha = this.textBoxSenha.Text;
            String instancia = this.comboBoxDataSource.Text;
            BancoDeDados.getInstance().salvaBancoDados(utilizarBd, nomeUsuario, senha, instancia);
            BancoDeDados.getInstance().salvaArquivoConfiguracao();
        }

        #endregion

        #region Eventos

        private void buttonCancelar_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void buttonAplicar_Click(object sender, EventArgs e)
        {
            this.salvarOpcoesBancoDados();
        }

        private void buttonOk_Click(object sender, EventArgs e)
        {
            this.salvarOpcoesBancoDados();
            this.Close();
        }

        #endregion
    }
}
