﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TestView.Seguranca;

namespace TestViewGUI.Excecoes
{
    public class GerenciadorAlerta
    {
        #region Construtor e membros

        private static GerenciadorAlerta _instance;

        public static void inicializaGerenciador()
        {
            if (_instance == null)
            {
                _instance = new GerenciadorAlerta();
            }
        }

        private GerenciadorAlerta()
        {
            Logging.getInstance().OnLogging += new Logging.OnLoggingEvent(onLogging);
        }

        #endregion

        #region Eventos

        private void onLogging(object sender, Logging.OnLoggingEventArgs e)
        {
            this.exibeAlerta(e.Nivel, e.Mensagem, e.Excecao);
        }

        private void exibeAlerta(NivelLog nivel, String mensagem, Exception excecao)
        {
            mensagem = mensagem.Replace(@"\r\n", System.Environment.NewLine);
            if (excecao == null)
            {
                FormAlertaMensagem alerta = new FormAlertaMensagem(nivel, mensagem);
                alerta.ShowDialog();
            }
            else
            {
                FormAlertaExcecao alerta = new FormAlertaExcecao(nivel, mensagem, excecao);
                alerta.ShowDialog();
            }
        }
        #endregion
    }
}
