﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using TestView.Ensaios.Utilidades.Instrumentacao;
using TestView.Utils;

namespace TestViewGUI.Instrumentacao
{
    public partial class FormExtensometro : Form
    {
        #region Construtor e membros

        private Extensometro _extensometro;
        private Double _le;

        public FormExtensometro(Extensometro extensometro)
        {
            InitializeComponent();
            this._extensometro = extensometro;
            this._le = this._extensometro.ComprimentoMedidaExtensometrico;
            this.textBoxLe.Text = String.Format("{0}", this._le);
        }

        #endregion

        #region Salvar

        private void salvarAlteracao()
        {
            this._extensometro.ComprimentoMedidaExtensometrico = this._le;
        }

        #endregion

        #region Eventos

        private void buttonCancelar_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void buttonOk_Click(object sender, EventArgs e)
        {
            this.salvarAlteracao();
            this.Close();
        }

        #endregion

        #region Validacao

        private void alternarAlertaValidacaoTextbox(TextBox textbox, string textoDica, bool alerta)
        {
            if (alerta)
            {
                textbox.BackColor = Color.LightSalmon;
                dica.Show(textoDica, textbox, textbox.Width, -20, 3000);
                textbox.SelectAll();
            }
            else
            {
                textbox.BackColor = SystemColors.Window;
            }
        }

        private void textboxNumericoNaoNuloValidating(object sender, CancelEventArgs e)
        {
            TextBox textbox = (TextBox)sender;
            string texto = textbox.Text;
            if (Validacao.validaTextoNumerico(texto))
            {
                if (!Validacao.validaValorNaoNulo(texto))
                {
                    e.Cancel = true;
                    this.alternarAlertaValidacaoTextbox(textbox, Properties.Resources.validaNumericoNaoNuloString, true);
                }
                else
                {
                    this.alternarAlertaValidacaoTextbox(textbox, null, false);
                }
            }
            else
            {
                e.Cancel = true;
                this.alternarAlertaValidacaoTextbox(textbox, Properties.Resources.validaNumericoNaoNuloString, true);
            }
        }

        private void textboxLeValidated(object sender, EventArgs e)
        {
            TextBox textboxLe = (TextBox)sender;
            this._le = Double.Parse(textboxLe.Text);
        }

        #endregion
    }
}
